

#if !defined __DARKWIN_H
#define __DARKWIN_H


#define COMM_MODE_IDLE   0
#define COMM_MODE_TARGET 1
#define COMM_MODE_ORDER  2

#define COMM_ATTACK           0
#define COMM_ESCORT           1
#define COMM_BODYGUARD        2
#define COMM_FALLOUT          3
#define COMM_ALL              8
#define COMM_ABORT            9


#ifdef WIN32

#include "user_io_w32.h"


/* **********************************************************************
********************************************************************** */

class dark_uio_win : public user_io_win {

   protected:
      int key2int();

   public:
      void get_events();
      
      int mode;
      sim_object *starget;

      dark_uio_win() { mode = COMM_MODE_IDLE; }
      virtual ~dark_uio_win() {}
};

#else

#include "user_io_x.h"


/* **********************************************************************
********************************************************************** */
class dark_uio_X : public user_io_X {

   protected:
      int key2int();

   public:
      void get_events();
      
      int mode;
      sim_object *starget;

      dark_uio_X() { mode = COMM_MODE_IDLE; }
      virtual ~dark_uio_X() {}
};

#endif

#endif
